package tests;

import static org.junit.Assert.*;

import org.junit.Test;

import implementation.Counter;

public class TestCounter2 {

	
//	@Test
//	public void testFailTrivially() {
//		fail("Not yet implemented");
//	}
//	
//	@Test
//	public void testPassTrivially() {
//		
//	}
	
	/*
	 * Since we are testing a utility class,
	 * there's only one copy of the attributes/methods.
	 * This means, the starting value of counter of a test method
	 * is no longer guaranteed to be MIN; instead, it will be
	 * the accumulated value from the previous test methods run.
	 * Fix: Reset explicitly all attributes to their initial values. 
	 */
	
	@Test
	public void testIncrementOnce() {
		Counter.value = Counter.MIN_COUNTER_VALUE;
		// Start with initial value of counter being MIN
		assertTrue(Counter.value == Counter.MIN_COUNTER_VALUE);
		Counter.increment();
		assertTrue(Counter.value == 1);
	}
	
	@Test
	public void testIncrementTwice() {
		Counter.value = Counter.MIN_COUNTER_VALUE;
		// Start with initial value of counter being MIN
		assertTrue(Counter.value == Counter.MIN_COUNTER_VALUE);
		Counter.increment();
		Counter.increment();
		assertTrue(Counter.value == 2);
	}
	
	// Now we want to test an abnormal scenario:
	// Say the current counter value is MIN,
	// and we try to decrement it.
	// Expected behaviour of the counter program is
	// to throw an IAE
	@Test
	public void testDecFromZero() {
		try {
			Counter.value = Counter.MIN_COUNTER_VALUE;
			Counter.decrement();
			// the expected IAE not thrown
			// FAIL!!
			fail("The expected IAE not thrown!");
		}
		catch(IllegalArgumentException e) {
			// The expected IAE was thrown.
			// Do nothing: success  
		} 
	}

}












